<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from builder.texi on 28 April 1999 -->

<TITLE>The Builder Library - Destination of results</TITLE>
<link href="builder_30.html" rel=Next>
<link href="builder_28.html" rel=Previous>
<link href="builder_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_28.html">previous</A>, <A HREF="builder_30.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC60" HREF="builder_toc.html#TOC60">Destination of the Results</A></H2>
<P>
<A NAME="IDX148"></A>
It is necessary to provide the destination of the created SUIF code
when calling a <CODE>make_..()</CODE> function.  When a destination is given,
all the types and symbols will be installed in the correct symbol
tables. Otherwise, appending the SUIF structures created in a
different scope can take some variable and types out of their valid
scope, creating inconsistent SUIF.  The destination can be given by
passing an optional parameter giving the <CODE>block_symtab</CODE> of the next
scope. The destination can also be specified by providing the SUIF
structure that will become the parent of the structure generated.  This
parent structure can be an <CODE>instruction</CODE>, a <CODE>tree_node</CODE> or a
<CODE>tree_node_list</CODE>.

</P>
<P>
<A NAME="IDX149"></A>
<A NAME="IDX150"></A>
<A NAME="IDX151"></A>

</P>

<PRE>
        tree_node * tn = ..
        var_sym * vs = ..
        block code(block(vs) = block(0));
        tree_node * init_tn = code.make_tree_node(tn-&#62;parent());
        tn-&#62;parent()-&#62;append_after(init_tn, tn-&#62;list_e());
</PRE>

<P>
<A NAME="IDX152"></A>

</P>
<P>
Note that if any variable used in the builder structure is not in the
scope of the destination, a new variable will be created, which may not
be intentional. Refer to the section on Cloning in the SUIF reference
manual for more details.
<A NAME="IDX153"></A>
<A NAME="IDX154"></A>

</P>
<P><HR><P>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_28.html">previous</A>, <A HREF="builder_30.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
</BODY>
</HTML>
